from tkinter import *
from tkinter import ttk
import tkinter
import cv2
import os
import time
import pandas as pd
import matplotlib as mpl
mpl.use('TkAgg')
import matplotlib.pyplot as plt
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg
import numpy as np
from keras.models import load_model
from keras.preprocessing.image import ImageDataGenerator
from keras.preprocessing import image
import glob
import openpyxl
import datetime
from tkinter import filedialog
import platform
import math 
import sys
import concurrent.futures

os.environ['TF_CPP_MIN_LOG_LEVEL'] = '2'


def resource_path(relative_path):
    try:
        base_path = sys._MEIPASS
    except Exception:
        base_path = os.path.dirname(__file__)
    return os.path.join(base_path, relative_path)

model_path = resource_path(".//cascade.xml")
cascade = cv2.CascadeClassifier(model_path)  


def creation_date(path_to_file):         
    if platform.system() == 'Windows':
        return os.path.getctime(path_to_file)
    else:
        stat = os.stat(path_to_file)
        try:
            return stat.st_birthtime
        except AttributeError:
            return stat.st_mtime
        

def _destroyWindow():   
    root.quit()
    root.destroy()
    
def askfileplace():
    cd =  filedialog.askdirectory()            
    path.set(cd)

def demo(device_num=0):                     
    gettime =  datetime.datetime.now()
    s = gettime.second

    if s <= 45:                            
        k = s +15
    else:
        k = ((s + 15)-60) 
   
    cap = cv2.VideoCapture(device_num) 
    model_path = resource_path(".//cascade.xml")
    cascade = cv2.CascadeClassifier(model_path)  
    
    while s!=k:                         
        ret, img = cap.read()
        gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)
        faces = cascade.detectMultiScale(gray, scaleFactor=1.3, minNeighbors=2)

        for x, y, w, h in faces:
            cv2.rectangle(img, (x, y), (x + w, y + h), (255, 0, 0), 2)

        cv2.imshow('LIVE 15seconds', img)
        gettime= datetime.datetime.now()
        s = gettime.second 
        
        key = cv2.waitKey(10) & 0xFF
        
    cap.release()
    cv2.destroyAllWindows()
    sys.exit()

def distance_calc(facey1,facex1,y_pixel,x_pixel,theta1,df):
    # copy right researved
    df=df.reset_index()
    a224a=float(facey1)   
    a324a=float(facex1)   
    a020a=a224a
    a340a=a324a
    a104a=y_pixel
    a102a=x_pixel
    a400a=a104a
    a107a=a102a
    a121a=float(theta1)
    a112a = a121a/2
    a111a = math.tan(math.radians(a112a))
    a412a = (a107a*a111a)/math.sqrt(a107a^2+a400a^2) 
    a136a = (a400a*a111a)/math.sqrt(a107a^2+a400a^2)     
    C=df["y2"][0]-df["y1"][0]              
    D=df["y2"][1]-df["y1"][1]   
    C=int(C)                             
    D=int(D)                            
    E=df["x2"][0]-df["x1"][0]              
    F=df["x2"][1]-df["x1"][1]  
    E=int(E)                             
    F=int(F)                                
    a512a = ( pow(a340a,2) ) * ( pow(a102a,2) ) *  pow((E-F),2) 
    a512a =float(a512a)
    a146a = (a412a**2) * ((a340a)**2)
    a146a = float(a146a)
    a151a=df["x2"][1]
    a161a=int(a151a)  
    a156a=df["x2"][0]
    a166a=int(a156a)  
    a169a = ( ( a102a - 2 * (a161a) ) * E - ( a102a - 2 * (a166a) ) * F )**2 
    a169a = float(a169a)
    a567a= 4 * (a412a**2) * (E**2) * (F**2)
    a567a= float(a567a)
    a570a = ( a512a + ( a146a * a169a ) ) / a567a
    a570a = float(a570a)
    a180a = ( a020a**2 ) * (a104a**2) * ((C-D)**2)
    a180a = float(a180a)
    a601a = (a136a**2) * ((a020a)**2)
    a601a = float(a601a)
    a199a = df["y2"][1]
    a211a = int(a199a)   
    a201a = df["y2"][0]
    a888a = int(a201a)   
    a217a = ( ( a104a - 2 * (a211a) ) * C - ( a104a - 2 * (a888a) ) * D ) **2
    a217a = float(a217a)
    a898a= 4 * (a136a**2) * (C**2) * (D**2)
    a898a = float(a898a)
    a220a = ( a180a + ( a601a * a217a ) ) / a898a
    a220a = float(a220a)
    a221a = math.sqrt(a220a+a570a)
    df.at[1,"Distance"]= a221a 
    return df


def analysis(device_num,interval1,duration1,facey1,facex1,theta1,path1):

    nowtime =  datetime.datetime.now().strftime("%Y%m%d_%H%M")
    nowtime = int(nowtime)
  
    cap = cv2.VideoCapture(device_num) 
    height,width,ch = cap.read()[1].shape   
    y_pixel = height
    x_pixel = width
    
    df = pd.DataFrame([],columns=["x1","y1","x2","y2","Year","Month","Day","Hour","Min","Sec","Date","Distance"]) 
   
    if not cap.isOpened():  
        return 
    
    if cascade.empty():      
        print('cannnot load cascade file')
        sys.exit()
       
    n = 0 
    while n <= ((float(duration1))*60*1)/int(interval1) : 
 
        ret, frame = cap.read() 
        gray = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)
        objects = cascade.detectMultiScale(gray, scaleFactor=1.3, minNeighbors=2)
            
        for x, y, w, h in objects:
            cv2.rectangle(frame, (x, y), (x + w, y + h), (255, 0, 0), 2)

        cv2.imshow('video image', frame)
        key = cv2.waitKey(1) & 0xFF   


        timestamp = datetime.datetime.now()
        year = timestamp.strftime('%Y')
        month = timestamp.strftime('%m')
        day = timestamp.strftime('%d')
        hour = timestamp.strftime('%H')
        minute = timestamp.strftime('%M')
        second = timestamp.strftime('%S') 
        date = year +"/"+ month  +"/"+ day +" "+hour+":"+minute+":"+second
            
        if not (len(objects)==0)or(len(objects)>1):  
            x1 =objects[0][0]
            y1 = objects[0][1]
            x2 =objects[0][0]+objects[0][2]
            y2 = objects[0][1]+objects[0][3]

            addRow=pd.Series([x1,y1,x2,y2,year,month,day,hour,minute,second,date,0],index=df.columns)
            df = df.append(addRow,ignore_index=True)

        else:  
            addRow=pd.Series([None,None,None,None,year,month,day,hour,minute,second,date,0],index=df.columns)
            df = df.append(addRow,ignore_index=True)
            time.sleep(int(interval1))
            n += 1
            continue
                
            
        nonNAlist = np.where(df["x1"].values != None)
        nonNAlist_length = len(nonNAlist[0])
        nonNAlist_length = int(nonNAlist_length)
            
        if ((nonNAlist_length)<=1) or (df.iloc[(len(df)-1),0] == None):    
            time.sleep(int(interval1))
            n += 1
            continue
                
        elif ((nonNAlist_length) == 2):
                        
            ROI = nonNAlist[0][-2:]
            df_add = df.iloc[ROI,:]
            df_add = distance_calc(facey1,facex1,y_pixel,x_pixel,theta1,df_add)
            df.iloc[(len(df)-1),:] = df_add.iloc[1,:]
        
            fig = plt.figure()
            ax = fig.add_subplot(1,1,1)
            ax.bar(df["Date"], df["Distance"], width=0.8,color="pink")
            fig.autofmt_xdate(rotation=45)
            ax.tick_params(axis='x', labelsize=6)
            plt.style.use('fivethirtyeight')
            plt.pause(int(interval1))
                

        elif ((nonNAlist_length) > 2):
                        
            ROI = nonNAlist[0][-2:]
            df_add = df.iloc[ROI,:]
            df_add = distance_calc(facey1,facex1,y_pixel,x_pixel,theta1,df_add)
            df.iloc[(len(df)-1),:] = df_add.iloc[1,:]
        

            plt.close()
                 
            fig = plt.figure()
            ax = fig.add_subplot(1,1,1)
            ax.bar(df["Date"], df["Distance"], width=0.8,color="pink")
            fig.autofmt_xdate(rotation=45)
            ax.tick_params(axis='x', labelsize=6)
            plt.style.use('fivethirtyeight')
            plt.pause(int(interval1))
                
                
        if ((n % 5) == 0):
            df.to_excel("{}//result{}{}{}.xlsx".format(path1,year,month,day), sheet_name='result')
            time.sleep(int(interval1))
            n = n + 1 

    df.to_excel("{}//result{}{}{}.xlsx".format(path1,year,month,day), sheet_name='result') 
    cap.release()
    cv2.destroyAllWindows()
    
root = Tk()
root.title('活動量測定AI')
root.resizable(True, True)


frame1 = ttk.Frame(root, padding=(32))
frame1.grid()

label1 = ttk.Label(frame1, text='撮影間隔(秒)', padding=(5, 2))
label1.grid(row=0, column=0, sticky=E)

label2 = ttk.Label(frame1, text='撮影時間(分)', padding=(5, 2))
label2.grid(row=1, column=0, sticky=E)

label3 = ttk.Label(frame1, text='猫の顔横幅(cm)', padding=(5, 2))
label3.grid(row=2, column=0, sticky=E)

label4 = ttk.Label(frame1, text='猫の顔立幅(cm)', padding=(5, 2))
label4.grid(row=3, column=0, sticky=E)

label5 = ttk.Label(frame1, text='カメラの対角画角(度)', padding=(5, 2))
label5.grid(row=4, column=0, sticky=E)

label6 = ttk.Label(frame1, text='結果の保存先', padding=(5, 2))
label6.grid(row=5, column=0, sticky=E)


interval = StringVar()
interval_entry = ttk.Entry(
    frame1,
    textvariable=interval,
    width=20)
interval_entry.insert(0,"10")
interval_entry.grid(row=0, column=1)

duration = StringVar()
duration_entry = ttk.Entry(
    frame1,
    textvariable=duration,
    width=20)
duration_entry.insert(0,"60")
duration_entry.grid(row=1, column=1)

facey = StringVar()
facey_entry = ttk.Entry(
    frame1,
    textvariable=facey,
    width=20)
facey_entry.insert(0,"8")
facey_entry.grid(row=2, column=1)

facex = StringVar()
facex_entry = ttk.Entry(
    frame1,
    textvariable=facex,
    width=20)
facex_entry.insert(0,"6")
facex_entry.grid(row=3, column=1)

theta = StringVar()
theta_entry = ttk.Entry(
    frame1,
    textvariable=theta,
    width=20)
theta_entry.insert(0,"60") 
theta_entry.grid(row=4, column=1)

path =StringVar()
path_entry = ttk.Entry(
    frame1,
    textvariable=path,
    width=20)
path_entry.grid(row=5, column=1)

path_button = ttk.Button(frame1,text="フォルダ選択",command= lambda : [askfileplace()] )
path_button.grid(row=5, column=2)


frame2 = ttk.Frame(frame1, padding=(0, 5))
frame2.grid(row=6, column=1, sticky=W)

button1 = ttk.Button(frame2, text='デモ', command= lambda : [demo()])
button1.pack(side=LEFT)

button2 = ttk.Button(
    frame2, text='撮影開始',
    command= lambda : [analysis(0,interval.get(),duration.get(),facey.get(),facex.get(),theta.get(),path.get())]) # read the function I made
button2.pack(side=LEFT)

button3 = ttk.Button(frame2, text='終了', command= lambda : [_destroyWindow()])
button3.pack(side=LEFT)

root.mainloop()